/**
 * @namespace flexygo.crm
 */
var flexygo;
(function (flexygo) {
    var crm;
    (function (crm) {
        /**
        * Enables Actuaciones edit form .
        * @method editLightActuaciones
        * @param {JQuery} itm - item clicked on.
        * @param {number} clasif - classification value.
        * @param {string} id -identificador del objeto.
        * @param {string} objectname - object name.
        */
        function editLightActuaciones(itm, clasif, id, objectname, otherId) {
            var editForm = itm.closest('flx-module').find('.actuacionlight flx-edit');
            if (editForm.length > 0) {
                if (editForm[0].defaults.ClasificacionCrm == clasif) {
                    itm.closest('flx-module').find('.actuacionlight').empty();
                    return;
                }
            }
            //Add edit form
            var editItm = $('<flx-edit objectname="crm_Actuacion_light" manualInit="true"></flx-edit>')[0];
            itm.closest('flx-module').find('.actuacionlight').html($(editItm));
            if (objectname == 'crm_cliente') {
                editItm.defaults = { "IdCliente": id, "ClasificacionCrm": clasif };
                editItm.refresh = function () {
                    $('[modulename="crm_clientes_Actuaciones_realizadas"] flx-list')[0].refresh();
                    $('[modulename="crm_clientes_Actuaciones_SiguientesPasos"] flx-list')[0].refresh();
                };
            }
            if (objectname == 'crm_oportunidad') {
                editItm.defaults = { "IdOportunidad": id, "ClasificacionCrm": clasif, "IdCliente": otherId };
                editItm.refresh = function () {
                    $('[modulename="crm_oportunidades_Actuaciones_realizadas"] flx-list')[0].refresh();
                    $('[modulename="crm_coportunidades_Actuaciones_SiguientesPasos"] flx-list')[0].refresh();
                };
            }
            if (objectname == '') {
                editItm.defaults = { "ClasificacionCrm": clasif };
                editItm.refresh = function () {
                    $('[modulename="crm_Mi_appointementButtons"] .actuacionlight').empty();
                    $('[modulename="crm_Tab_Mis_Pendientes"] flx-list')[0].refresh();
                };
            }
            editItm.init();
        }
        crm.editLightActuaciones = editLightActuaciones;
        /**
        * injects the filter of an object module list, into a module of the same type. When the user filtering the collection, inject the sql filter and presets filters, then execute refresh action in a depending module.
        * @method moduleListFilterCapture
        * @param {string} dependingModuleName - name of the depending module object list.
        * @param {string} parentModuleName - name of the parent module object list.
        */
        function moduleListFilterCapture(dependingModuleName, parentModuleName) {
            var opToList = $('flx-module[modulename="' + dependingModuleName + '"] flx-list');
            var opList = $('flx-module[modulename="' + parentModuleName + '"] flx-list');
            if (opList[0] && opToList[0]) {
                var opToListItm_1 = opToList[0];
                var opListItm_1 = opList[0];
                opToListItm_1.presets = opListItm_1.presets;
                flexygo.events.off(opList, 'module', 'filtered');
                flexygo.events.on(opList, 'module', 'filtered', function (e) {
                    if (e.sender === opList.closest('flx-module')[0]) {
                        opToListItm_1.activeFilter = opListItm_1.activeFilter;
                        opToListItm_1.filterValues = opListItm_1.filterValues;
                        opToListItm_1.setPreset(opListItm_1.presetId, opListItm_1.presetText, opListItm_1.presetIcon);
                    }
                });
            }
        }
        crm.moduleListFilterCapture = moduleListFilterCapture;
        /**
        * Change offer state.
        * @method crmOferta_ActualizaEstado
        * @param {number} IdOferta - offer identifier.
        * @param {number} Revision - offer rev identifier.
        * @param {number} EstadoActual - actual offer state number.
        * @param {number} NuevoEstado - new offer state number.
        */
        function crmOferta_ActualizaEstado(e, IdOferta, Revision, IdTipoCliente, EstadoActual, NuevoEstado) {
            if (NuevoEstado != EstadoActual) {
                switch (true) {
                    case NuevoEstado == -2:
                        flexygo.msg.confirm(flexygo.localization.translate('crm_oferta.confirm_estado_visada'), function (ret) { if (ret)
                            flexygo.nav.execProcess('crm_Oferta_CambiaEstado_Visar', 'crm_Oferta', '(Ofertas_Cli_Cabecera.IdOferta=' + IdOferta + ' AND Revision=' + Revision + ')', 'null', null, 'modal640x480', false, e, null, true); });
                        break;
                    case NuevoEstado == -1:
                        flexygo.msg.confirm(flexygo.localization.translate('crm_oferta.confirm_estado_rechazada'), function (ret) {
                            if (ret)
                                flexygo.nav.execProcess('crm_Oferta_CambiaEstado_Rechazar', 'crm_Oferta', '(Ofertas_Cli_Cabecera.IdOferta = ' + IdOferta + ' AND Revision = ' + Revision + ')', 'null', null, 'modal640x480', false, e);
                        });
                        break;
                    case NuevoEstado == 0:
                        flexygo.msg.confirm(flexygo.localization.translate('crm_oferta.confirm_estado_generada'), function (ret) { if (ret)
                            flexygo.nav.execProcess('crm_Oferta_CambiaEstado_Generada', 'crm_Oferta', '(Ofertas_Cli_Cabecera.IdOferta=' + IdOferta + ' AND Revision=' + Revision + ')', 'null', null, 'modal640x480', false, e, null, true); });
                        break;
                    case NuevoEstado == 1:
                        if (IdTipoCliente == -1) {
                            flexygo.msg.alert(flexygo.localization.translate('crm_oferta.alert_estado_aceptada_clipot'));
                        }
                        else {
                            flexygo.msg.confirm(flexygo.localization.translate('crm_oferta.confirm_estado_aceptada'), function (ret) {
                                if (ret)
                                    flexygo.nav.execProcess('crm_Oferta_CambiaEstado_Aceptar', 'crm_Oferta', '(Ofertas_Cli_Cabecera.IdOferta=' + IdOferta + ' AND Revision=' + Revision + ')', 'null', null, 'modal640x480', false, e, null, true);
                            });
                            break;
                        }
                }
            }
        }
        crm.crmOferta_ActualizaEstado = crmOferta_ActualizaEstado;
        /**
        * Change opportunity state.
        * @method crmOferta_ActualizaEstado
        * @param {number} IdOferta - offer identifier.
        * @param {number} Revision - offer rev identifier.
        * @param {number} EstadoActual - actual offer state number.
        * @param {number} NuevoEstado - new offer state number.
        */
        function crmOportunidad_ActualizaEstado(e, IdOportunidad, Estadoactual, NuevoEstado) {
            if (Estadoactual != NuevoEstado) {
                if (NuevoEstado != 5) {
                    flexygo.msg.confirm(flexygo.localization.translate('crm_oportunidad.confirm_estado'), function (ret) { if (ret)
                        flexygo.nav.execProcess('crm_OportunidadCambiaEstado', 'crm_Oportunidad', '(CRM_Oportunidades.IdOportunidad = ' + IdOportunidad + ')', null, [{ "key": 'IdEstado', "value": NuevoEstado }], 'popup640x480', false, e); });
                }
                else {
                    flexygo.nav.execProcess('crm_oportunidades_finalizar', 'crm_Oportunidad', '(CRM_Oportunidades.IdOportunidad = ' + IdOportunidad + ') ', 'null', null, 'popup640x480', false, e);
                }
            }
        }
        crm.crmOportunidad_ActualizaEstado = crmOportunidad_ActualizaEstado;
        /**
        * Comprobar si hay un cliente con el mismo email.
        * @method crmCliente_ComprobarEmail
        * @param {number} cantreg - cantidad de clientes que se encontrón coincidencia.
        * @param {string} email - el email en cuestión.
        * @param {string} idcliente - el cliente en cuestión, viene vacío si estamos creando uno nuevo.
        */
        function crmCliente_ComprobarEmail(cantreg, email, idcliente) {
            var lmsg = '';
            var lwhere = '(Clientes_Datos.Padre is null AND Clientes_Datos.E_Mail=\'' + email + '\')';
            var ltipo = "list";
            var lobj = "crm_Clientes";
            if (idcliente != '') {
                lwhere = '(Clientes_Datos.Padre is null AND Clientes_Datos.E_Mail=\'' + email + '\' AND Clientes_Datos.IdCliente<>\'' + idcliente + '\')';
            }
            if (cantreg == 1) {
                lmsg = flexygo.localization.translate('crm_cliente.confirm_emailcliente');
                ltipo = 'view';
                lobj = 'crm_Cliente';
            }
            else {
                lmsg = flexygo.localization.translate('crm_cliente.confirm_emailclientes');
            }
            flexygo.msg.confirm(lmsg, function (ret) { if (ret)
                flexygo.nav.openPage(ltipo, lobj, lwhere, 'null', 'new', false, $(this)); });
            //if (confirm(lmsg)) {
            //    flexygo.nav.openPage(ltipo, lobj, lwhere, 'null', 'new', false, $(this))
            //}    
        }
        crm.crmCliente_ComprobarEmail = crmCliente_ComprobarEmail;
        ;
        /**
        * Comprobar si hay un cliente con el mismo teléfono.
        * @method crmCliente_ComprobarTel
        * @param {number} cantreg - cantidad de clientes que se encontrón coincidencia.
        * @param {string} tel - el teléfono en cuestión.
        * @param {string} idcliente - el cliente en cuestión, viene vacío si estamos creando uno nuevo.
        */
        function crmCliente_ComprobarTel(cantreg, tel, idcliente) {
            var lmsg = '';
            var lwhere = '(Clientes_Datos.Padre is null AND Clientes_Datos.NumTelefono=\'' + tel + '\')';
            var ltipo = "list";
            var lobj = "crm_Clientes";
            if (idcliente != '') {
                lwhere = '(Clientes_Datos.Padre is null AND Clientes_Datos.NumTelefono=\'' + tel + '\' AND Clientes_Datos.IdCliente<>\'' + idcliente + '\')';
            }
            if (cantreg == 1) {
                lmsg = flexygo.localization.translate('crm_cliente.confirm_telcliente');
                ltipo = 'view';
                lobj = 'crm_Cliente';
            }
            else {
                lmsg = flexygo.localization.translate('crm_cliente.confirm_telclientes');
            }
            flexygo.msg.confirm(lmsg, function (ret) { if (ret)
                flexygo.nav.openPage(ltipo, lobj, lwhere, 'null', 'new', false, $(this)); });
        }
        crm.crmCliente_ComprobarTel = crmCliente_ComprobarTel;
        ;
        /**
        * Montar gráfica compañias.
        * @method crmGrafica_Compañias
        * @param {number} IdCompañia - Identificador de la compañia.
        */
        function crmGrafica_Compañias(IdCompañia) {
            var companies = new flexygo.obj.Entity('crm_Companias', 'IdCompañia=' + IdCompañia);
            var companiesData = companies.getView('crm_CompaniaDefaultList', null, null, null, null);
            $.each(companiesData, function (index, value) {
                $("#mod-crm_Compania_Grafica").append("<div class='flx- orgchart Treant Treant-loaded' id='myid-" + companiesData[index]["IdCompañia"] + "' style='overflow- x: auto;'></div>");
                var config = {
                    chart: {
                        container: "#myid-" + companiesData[index]["IdCompañia"], rootOrientation: "WEST", scrollbar: "fancy", connectors: { type: "step" }, nodeAlign: "BOTTOM", siblingSeparation: 15
                    },
                    nodeStructure: {
                        innerHTML: crmGrafica_Compañias_Nodo(true, companiesData[index]["IdCompañia"], companiesData[index]["Nombre de la compañia"], 0, 0, false, companiesData[index]["Direccion"], companiesData[index]["Ciudad"]),
                        children: []
                    }
                };
                var clients = new flexygo.obj.Entity('crm_Clientes', "Nivel = 0");
                var clientsData = clients.getView('crm_ClientesSimpleView', null, null, "IdCompañia = " + companiesData[index]["IdCompañia"], null);
                $.each(clientsData, function (ind, val) {
                    config.nodeStructure.children.push({ innerHTML: crmGrafica_Compañias_Nodo(false, clientsData[ind]["IdCliente"], clientsData[ind]["Cliente"], clientsData[ind]["IdTipo"], clientsData[ind]["Nivel"], clientsData[ind]["Bloqueado"], clientsData[ind]["Direccion"], clientsData[ind]["Ciudad"]), children: [] });
                    var delegations = new flexygo.obj.Entity('crm_Clientes', "Nivel = 1");
                    var delegationsData = delegations.getView('crm_ClientesSimpleView', null, null, "Padre = '" + clientsData[ind]["IdCliente"] + "'", null);
                    $.each(delegationsData, function (i, v) {
                        config.nodeStructure.children[ind].children.push({ innerHTML: crmGrafica_Compañias_Nodo(false, delegationsData[i]["IdCliente"], delegationsData[i]["Cliente"], delegationsData[i]["IdTipo"], delegationsData[i]["Nivel"], delegationsData[i]["Bloqueado"], delegationsData[i]["Direccion"], delegationsData[i]["Ciudad"]) });
                    });
                });
                var my_chart = new Treant(config);
            });
        }
        crm.crmGrafica_Compañias = crmGrafica_Compañias;
        ;
        /**
        * Montar nodo gráfica compañias.
        * @method crmGrafica_Compañias_Nodo flx-icon icon-team
        */
        function crmGrafica_Compañias_Nodo(esCompañia, Id, Nombre, IdTipo, Nivel, Bloqueado, Direccion, Ciudad) {
            var template = "<flx-navbutton type=\"openpage\" pagetypeid=\"view\" objectname=\"" + (esCompañia ? 'crm_Compania' : 'crm_Cliente') + "\" objectwhere=\"" + (esCompañia ? "(Clientes_Compañias.IdCompañia=" + Id + ")" : "(Clientes_Datos.IdCliente='" + Id + "')") + "\" defaults=\"\" targetid=\"current\" excludehist=\"false\">\n                            <div class=\"crm-card clickable\">\n                                <div class=\"imgdiv\">\n                                    <i class=\"flx-icon " + (esCompañia ? 'icon-team' : (Nivel == 1) ? 'icon-delegations-2' : (IdTipo == -1) ? 'icon-user' : 'icon-man') + " icon-2x icon-margin-right " + (esCompañia ? 'txt-tools' : (Bloqueado == true) ? 'text-muted' : (IdTipo == -1) ? 'txt-warning' : 'txt-outstanding') + "\"></i>\n                                </div>\n                                <div  class=\"carddiv\">\n\t                                <p class=\"title " + ((Direccion || Ciudad) ? '' : 'margin-bottom-0') + "\"><strong>" + Nombre + "</strong><small class=\"" + ((Bloqueado == true) ? 'txt-danger' : '') + "\"> " + ((Bloqueado == true) ? '(Bloqueado)' : '') + "</small></p>\n                                    <span class=\"" + ((Direccion) ? '' : 'hidden') + "\">" + Direccion + "</span>\n                                    <br class=\"" + ((Direccion) ? '' : 'hidden') + "\">\n                                    <span class=\"" + ((Ciudad) ? '' : 'hidden') + "\">" + Ciudad + "</span>\n                                </div>\n                            </div>\n                        </flx-navbutton>";
            return template;
        }
    })(crm = flexygo.crm || (flexygo.crm = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=crm.js.map