import { s as setMode } from './index-fec85944.js';
import { i as ionicCoreGlobalScript } from './ionic-global-98e9caed.js';
import { m as msg } from './messages-7ba0bfcd.js';
import { n as nav } from './navigation-1d81491e.js';
import { C as ConftokenProvider, m as moment, u as util, s as sql, a as ConftokenService } from './utils-f5a4ba73.js';
import { $ } from './jquery-434b2007.js';
import { c as cam } from './camera-3213ebb9.js';
import { w as whiteboard } from './whiteboard-f9d6e423.js';
import { g as gps } from './location-c41cbf0a.js';

const ioniconsGlobalScript = () => {
    setMode((el) => el.tagName === 'ION-ICON' ? el.mode || el.getAttribute('mode') : null);
};

var forms;
(function (forms) {
    async function save(btn) {
        let tkn = await ConftokenProvider.config();
        let edit = $(btn).closest('flx-edit')[0];
        if ($(edit).find('form').valid()) {
            let tableName = tkn.objectConfig[edit.object].tableName;
            let props = $(edit).find('[property]');
            let values = new Array();
            let fields = new Array();
            for (let i = 0; i < props.length; i++) {
                let prop = $(props[i]);
                fields.push(prop.attr('property'));
                let val = (prop.val() == '' ? null : prop.val());
                values.push(val);
            }
            if (edit.filter) {
                fields.push('_isUpdated');
                values.push(1);
                fields.push('_updatedDate');
                values.push(moment().toDate());
                fields.push('_rowguid');
                values.push(util.GUID());
                let UpdateScript = sql.getUpdateScript(tableName, fields, edit.filter);
                return sql.execSQL(UpdateScript, values).then(() => { console.log(1); msg.success("Saved :)"); }).catch(err => { throw err; });
            }
            else {
                let keys = tkn.objectConfig[edit.object].primaryKeys;
                for (let i = 0; i < keys.length; i++) {
                    let val = $(edit).find('[property="' + keys[i] + '"]');
                    if (val.length == 0 || val[0].value == null || val[0].value == '') {
                        throw 'Object has not primary key.';
                    }
                }
                fields.push('_isInserted');
                values.push(1);
                fields.push('_insertDate');
                values.push(moment().toDate());
                fields.push('_rowguid');
                values.push(util.GUID());
                let InserScript = sql.getInsertScript(tableName, fields);
                return sql.execSQL(InserScript, values).then(() => { console.log(1); msg.success("Saved :)"); }).catch(err => { throw err; });
            }
        }
        else {
            throw 'Complete all required fields: ' + $(edit).find('form').validate().errorList[0].element.name;
        }
    }
    forms.save = save;
})(forms || (forms = {}));

var ext;
(function (ext) {
    async function linkExternalFunctions() {
        window['flexygo'] = new Object();
        window.flexygo.nav = nav;
        window.flexygo.msg = msg;
        window.flexygo.sql = sql;
        window.flexygo.forms = forms;
        window.flexygo.camera = cam;
        window.flexygo.whiteboard = whiteboard;
        window.flexygo.gps = gps;
        window.flexygo.conftoken = await ConftokenProvider.config();
        window['$'] = $;
    }
    ext.linkExternalFunctions = linkExternalFunctions;
})(ext || (ext = {}));

const appGlobalScript = () => {
    ext.linkExternalFunctions();
};
window.addEventListener("message", receiveMessage, false);
function receiveMessage(event) {
    if (event.data && event.data.action) {
        switch (event.data.action) {
            case 'reload':
                window.location.reload();
                break;
            case 'syncTemplates':
                (new ConftokenService()).getAppTemplates().then(() => {
                    window.location.reload();
                });
                break;
            case 'navigate':
                if (event.data.type == 'view') {
                    util.getFirstRow(event.data.object).then((ret) => {
                        if (ret) {
                            nav.goPage(event.data.type, event.data.object, event.data.pagename, ret, null, 'root');
                        }
                        else {
                            alert('Can\'t find any object to go view page');
                        }
                    });
                }
                else {
                    nav.goPage(event.data.type, event.data.object, event.data.pagename, null, null, 'root');
                }
                break;
        }
    }
}

const globalScripts = () => {
  appGlobalScript();
  ionicCoreGlobalScript();
  ioniconsGlobalScript();
};

export { globalScripts as g };
