import { r as registerInstance, h } from './index-fec85944.js';
import './platform-2a611cf9.js';
import './config-d81853ed.js';
import './messages-7ba0bfcd.js';
import { n as nav } from './navigation-1d81491e.js';
import { C as ConftokenProvider, W as Webapi } from './utils-f5a4ba73.js';
import './jquery-434b2007.js';
import './helpers-a93fc877.js';
import './animation-db299241.js';
import './index-74c3e427.js';
import './index-97b20fff.js';
import './constants-7622a3ef.js';
import { m as menuController } from './index-268bb23e.js';
import './overlays-e40b14c2.js';

const appRootCss = ".icon-inner .flx-icon,.icon-inner .fa{font-size:20px;margin:3px;color:rgba(var(--ion-text-color-rgb, 0, 0, 0), 0.54)}ion-fab-button[data-desc]{position:relative}ion-fab-button[data-desc]::after{position:absolute;content:attr(data-desc);z-index:1;right:55px;bottom:4px;background-color:var(--ion-color-base);color:var(--ion-color-contrast);padding:9px;border-radius:8px;box-shadow:0 3px 5px -1px rgba(0,0,0,0.2), 0 6px 10px 0 rgba(0,0,0,0.14), 0 1px 18px 0 rgba(0,0,0,0.12)}.square-container{padding:8px}.square{width:calc(100% / 2);float:left;position:relative}.square .content{width:calc(100% - 16px);max-width:252px;max-height:252px;height:calc(100% - 16px);margin:8px;padding:16px;color:var(--ion-color-white-contrast);background-color:var(--ion-color-white);box-shadow:0 2px 5px rgba(0, 0, 0, 0.26);text-align:center;cursor:pointer}.square:nth-child(odd) .content{float:right}.square .content:hover{background-color:var(--ion-color-white-shade)}.square .content:hover i{background-color:var(--ion-color-outstanding-light-shade)}.square .content i{color:var(--ion-color-outstanding-light-contrast);background-color:var(--ion-color-outstanding-light);border-radius:50%;display:inline-block;font-size:50px;line-height:75px;width:75px;height:75px}";

const AppRoot = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.menuItems = new Array();
    }
    componentWillLoad() {
        this.loadMenus();
    }
    loadMenus() {
        ConftokenProvider.config().then((conf) => {
            if (conf && conf.menuConfig)
                this.menuItems = conf.menuConfig;
        });
    }
    controllMenu(ev) {
        menuController.close();
        let page = ev.detail.to;
        page.toLowerCase();
        let api = new Webapi();
        if (!page.startsWith('/login')) {
            api.getAuth().then((auth) => {
                if (!auth || !auth.b64) {
                    nav.goLogin();
                }
                else {
                    ConftokenProvider.currentApp().then((app) => {
                        if (!app) {
                            nav.goLogin();
                        }
                        else {
                            if (!page.startsWith('/sync')) {
                                ConftokenProvider.config().then((config) => {
                                    if (!config) {
                                        nav.goSync();
                                    }
                                });
                            }
                        }
                    });
                }
            });
        }
        if (page.startsWith('/login') || page.startsWith('/sync')) {
            menuController.enable(false);
        }
        else {
            menuController.enable(true);
        }
    }
    menuClick(menuItem) {
        nav._goMenu(menuItem);
    }
    render() {
        return ([
            h("ion-app", null, h("ion-menu", { "content-id": "menu-content" }, h("ion-header", null, h("ion-toolbar", { color: "header" }, h("ion-title", null, "Menu"))), h("ion-content", null, h("ion-list", null, h("ion-item", { onClick: () => nav.goHome() }, h("ion-label", null, "Home"), h("ion-icon", { name: "home" })), this.menuItems.map((item) => h("ion-item", { onClick: () => this.menuClick(item) }, h("ion-label", null, item.title), h("div", { class: "icon-inner" }, h("i", { class: item.iconClass })))), h("ion-item", { onClick: () => nav.goSync() }, h("ion-label", null, "Sync"), h("ion-icon", { name: "repeat" })), h("ion-item", { onClick: () => nav.goLogin() }, h("ion-label", null, "LogOut"), h("ion-icon", { name: "exit" }))))), h("ion-content", { id: "menu-content" }, h("ion-router", { useHash: true, onIonRouteWillChange: ev => this.controllMenu(ev) }, h("ion-route", { url: "/", component: "flx-home" }), h("ion-route", { url: "/home", component: "flx-home" }), h("ion-route", { url: "/login", component: "flx-login" }), h("ion-route", { url: "/sync", component: "flx-sync" }), h("ion-route", { url: "/list/:object", component: "flx-list" }), h("ion-route", { url: "/list/:object/page/:pageName/", component: "flx-list" }), h("ion-route", { url: "/list/:object/page/:pageName/filter/:filter/", component: "flx-list" }), h("ion-route", { url: "/list/:object/page/:pageName/defaults/:defaults", component: "flx-list" }), h("ion-route", { url: "/list/:object/page/:pageName/filter/:filter/defaults/:defaults", component: "flx-list" }), h("ion-route", { url: "/list/:object/filter/:filter", component: "flx-list" }), h("ion-route", { url: "/list/:object/filter/:filter/defaults/:defaults", component: "flx-list" }), h("ion-route", { url: "/list/:object/defaults/:defaults", component: "flx-list" }), h("ion-route", { url: "/view/:object", component: "flx-view" }), h("ion-route", { url: "/view/:object/page/:pageName/", component: "flx-view" }), h("ion-route", { url: "/view/:object/page/:pageName/filter/:filter/", component: "flx-view" }), h("ion-route", { url: "/view/:object/page/:pageName/defaults/:defaults", component: "flx-view" }), h("ion-route", { url: "/view/:object/page/:pageName/filter/:filter/defaults/:defaults", component: "flx-view" }), h("ion-route", { url: "/view/:object/filter/:filter", component: "flx-view" }), h("ion-route", { url: "/view/:object/filter/:filter/defaults/:defaults", component: "flx-view" }), h("ion-route", { url: "/view/:object/defaults/:defaults", component: "flx-view" }), h("ion-route", { url: "/edit/:object", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/page/:pageName/", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/page/:pageName/filter/:filter/", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/page/:pageName/defaults/:defaults", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/page/:pageName/filter/:filter/defaults/:defaults", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/filter/:filter", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/filter/:filter/defaults/:defaults", component: "flx-edit" }), h("ion-route", { url: "/edit/:object/defaults/:defaults", component: "flx-edit" }), h("ion-route", { url: "/gallery/", component: "flx-imagemanager" }), h("ion-route", { url: "/gallery/:object/:objectid", component: "flx-imagemanager" }), h("ion-route", { url: "/documents/", component: "flx-imagemanager" }), h("ion-route", { url: "/documents/:object/:objectid", component: "flx-documentmanager" })), h("ion-nav", null)))
        ]);
    }
};
AppRoot.style = appRootCss;

export { AppRoot as app_root };
