import { r as registerInstance, h, c as getElement } from './index-fec85944.js';
import './platform-2a611cf9.js';
import './config-d81853ed.js';
import './messages-7ba0bfcd.js';
import { s as sql } from './utils-f5a4ba73.js';
import { $ } from './jquery-434b2007.js';
import './helpers-a93fc877.js';
import './animation-db299241.js';
import './index-74c3e427.js';
import './index-97b20fff.js';
import './constants-7622a3ef.js';
import './index-268bb23e.js';
import { m as modalController } from './overlays-e40b14c2.js';

const flxDbcomboCss = "flx-dbcombo{width:100%}flx-dbcombo ion-input{width:calc(100% - 60px);max-width:calc(100% - 60px);float:left}flx-dbcombo ion-button{width:30px;float:right}";

const FlxDbcombo = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.table = [];
    }
    componentWillLoad() {
        this.load();
    }
    watchHandler() {
        this.load();
    }
    load() {
        if (this.sqlsentence) {
            this.template = `<ion-label onclick="$(document).trigger('select', ['{{${this.valuefield}|JS}}','{{${this.displayfield}|JS}}']);">{{${this.displayfield}}}</ion-label>`;
            if (this.value != null) {
                debugger;
                let sentence = sql.addWhere(this.sqlsentence, this.filter);
                sentence = sql.addWhere(sentence, this.additional);
                sentence = sql.addWhere(sentence, `\`${this.valuefield}\`=?`);
                sql.getValue(sentence, [this.value]).then((txt) => {
                    this.text = txt;
                });
            }
        }
    }
    async showItems(_ev) {
        let component = `
        <ion-fab vertical="top" horizontal="end" slot="fixed">
            <ion-fab-button color="dark" onclick="$(document).trigger('cancelSelect');">
                <ion-icon name="close"></ion-icon>
            </ion-fab-button>
        </ion-fab>
        <ion-content class="placeholder">
            <ion-header>
                <ion-searchbar autocomplete="off" animated="true" ></ion-searchbar>
            </ion-header>
        </ion-content>
        `;
        const modal = await modalController.create({
            component: 'ion-content'
        });
        await modal.present();
        $(modal).find('.ion-page').html(component);
        let list = document.createElement('flx-sqllist');
        let sentence = sql.addWhere(this.sqlsentence, this.filter);
        sentence = sql.addWhere(sentence, this.additional);
        list.setAttribute("sqlsentence", sentence);
        list.setAttribute("orderby", this.orderby);
        $(list).append($('<script class="bodyTemplate" type="text/template"></script>').text(this.template));
        $(modal).find('.ion-page .placeholder').append(list);
        let mBar = $(modal).find('ion-searchbar');
        mBar.off('ionChange').on('ionChange', () => {
            if (mBar.val()) {
                list.params = ['%' + mBar.val() + '%'];
                list.additional = `\`${this.displayfield}\` like ? `;
            }
            else {
                list.params = [];
                list.additional = null;
            }
        });
        setTimeout(() => { mBar[0].setFocus(); }, 500);
        $(document).off('select').on('select', (_ev, value, text) => {
            this.value = value;
            this.text = text;
            modal.dismiss();
            $(document).off('select');
            $(document).off('cancelSelect');
            debugger;
            $(this.me).trigger('change');
        });
        $(document).off('cancelSelect').on('cancelSelect', (_ev) => {
            modal.dismiss();
            $(document).off('select');
            $(document).off('cancelSelect');
        });
    }
    render() {
        return ([h("ion-input", { type: "text", readonly: true, value: this.text, onClick: (ev) => { this.showItems(ev); } }),
            h("ion-button", { onClick: () => { this.value = null; this.text = null; }, shape: "round", slot: "end", color: "light" }, "x")
        ]);
    }
    get me() { return getElement(this); }
    static get watchers() { return {
        "sqlsentence": ["watchHandler"]
    }; }
};
FlxDbcombo.style = flxDbcomboCss;

export { FlxDbcombo as flx_dbcombo };
