import { r as registerInstance, h } from './index-fec85944.js';
import './messages-7ba0bfcd.js';
import { C as ConftokenProvider } from './utils-f5a4ba73.js';
import './jquery-434b2007.js';

const flxStylesCss = "flx-styles{}";

const FlxStyles = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    async componentWillLoad() {
        this.style = [];
        await this.load();
    }
    async load() {
        let cnfTok = await ConftokenProvider.config();
        if (cnfTok && cnfTok.styleConfig) {
            this.style = cnfTok.styleConfig;
        }
    }
    async refresh() {
        await this.load();
    }
    render() {
        return this.style.map((itm) => {
            return h("style", { id: itm.name, innerHTML: itm.cssCode + '\n\n' + '/*@ sourceURL=' + itm.name + '.css */' });
        });
    }
};
FlxStyles.style = flxStylesCss;

export { FlxStyles as flx_styles };
