import { r as registerInstance, h, H as Host } from './index-fec85944.js';
import './platform-2a611cf9.js';
import './config-d81853ed.js';
import { g as getIonMode } from './ionic-global-98e9caed.js';

const itemGroupIosCss = "ion-item-group{display:block}.item-group-ios ion-item:last-child,.item-group-ios ion-item-sliding:last-child .item{--border-width:0}";

const itemGroupMdCss = "ion-item-group{display:block}.item-group-md ion-item:last-child,.item-group-md ion-item-sliding:last-child ion-item{--border-width:0}";

const ItemGroup = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    render() {
        const mode = getIonMode(this);
        return (h(Host, { role: "group", class: {
                [mode]: true,
                // Used internally for styling
                [`item-group-${mode}`]: true,
                'item': true
            } }));
    }
};
ItemGroup.style = {
    /*STENCIL:MODE:ios*/ ios: itemGroupIosCss,
    /*STENCIL:MODE:md*/ md: itemGroupMdCss
};

export { ItemGroup as ion_item_group };
