import { r as registerInstance, d as createEvent, h, H as Host, c as getElement } from './index-fec85944.js';
import './platform-2a611cf9.js';
import './config-d81853ed.js';
import { g as getIonMode } from './ionic-global-98e9caed.js';
import { c as createColorClasses } from './theme-1a9eb2db.js';

const segmentIosCss = ".sc-ion-segment-ios-h{--indicator-color-checked:initial;--ripple-color:currentColor;--color-activated:initial;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;display:flex;align-items:stretch;justify-content:center;width:100%;font-family:var(--ion-font-family, inherit);text-align:center}.segment-disabled.sc-ion-segment-ios-h,.sc-ion-segment-ios-s>.segment-button-disabled{pointer-events:none}.segment-scrollable.sc-ion-segment-ios-h{justify-content:start;width:auto;overflow-x:scroll}.segment-scrollable.sc-ion-segment-ios-h::-webkit-scrollbar{display:none}.sc-ion-segment-ios-h{--background:transparent;--background-hover:rgba(var(--ion-color-primary-rgb, 56, 128, 255), 0.1);--background-activated:rgba(var(--ion-color-primary-rgb, 56, 128, 255), 0.16);--background-checked:var(--ion-color-primary, #3880ff);--color:var(--ion-color-primary, #3880ff);--color-checked:var(--ion-color-primary-contrast, #fff);--color-disabled:rgba(var(--ion-color-primary-rgb, 56, 128, 255), 0.3);--color-checked-disabled:rgba(var(--ion-color-primary-contrast-rgb, 255, 255, 255), 0.3);--border-color:var(--ion-color-primary, #3880ff);--indicator-color:transparent}.segment-disabled.sc-ion-segment-ios-h{opacity:0.3}.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>ion-segment-button{--border-color:var(--ion-color-base);background:transparent;color:var(--ion-color-base)}.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>.activated{background:rgba(var(--ion-color-base-rgb), 0.16);color:var(--ion-color-base)}.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>.segment-button-checked.activated,.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>.segment-button-checked{background:var(--ion-color-base);color:var(--ion-color-contrast)}.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>.segment-button-disabled{color:rgba(var(--ion-color-base-rgb), 0.3)}.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>.segment-button-checked.segment-button-disabled{color:rgba(var(--ion-color-contrast-rgb), 0.3)}@media (any-hover: hover){.sc-ion-segment-ios-h.ion-color.sc-ion-segment-ios-s>ion-segment-button:hover:not(.segment-button-checked){background:rgba(var(--ion-color-base-rgb), 0.1)}}.sc-ion-segment-ios-hion-toolbar.sc-ion-segment-ios-s>ion-segment-button,ion-toolbar .sc-ion-segment-ios-h.sc-ion-segment-ios-s>ion-segment-button{max-width:100px;font-size:12px;line-height:22px}.sc-ion-segment-ios-hion-toolbar:not(.ion-color):not(.ion-color).sc-ion-segment-ios-s>ion-segment-button,ion-toolbar:not(.ion-color) .sc-ion-segment-ios-h:not(.ion-color).sc-ion-segment-ios-s>ion-segment-button{border-color:var(--ion-toolbar-color-checked, var(--border-color));color:var(--ion-toolbar-color-unchecked, var(--color))}.sc-ion-segment-ios-hion-toolbar:not(.ion-color):not(.ion-color).sc-ion-segment-ios-s>.segment-button-checked,ion-toolbar:not(.ion-color) .sc-ion-segment-ios-h:not(.ion-color).sc-ion-segment-ios-s>.segment-button-checked{background:var(--ion-toolbar-color-checked, var(--background-checked));color:var(--ion-toolbar-background, var(--color-checked))}.sc-ion-segment-ios-hion-toolbar.ion-color:not(.ion-color).sc-ion-segment-ios-s>ion-segment-button,ion-toolbar.ion-color .sc-ion-segment-ios-h:not(.ion-color).sc-ion-segment-ios-s>ion-segment-button{--color:var(--ion-color-contrast);--color-disabled:rgba(var(--ion-color-contrast-rgb), 0.3);--color-checked:var(--ion-color-base);--color-checked-disabled:rgba(var(--ion-color-contrast-rgb), 0.3);--background-hover:rgba(var(--ion-color-contrast-rgb), 0.1);--background-activated:rgba(var(--ion-color-contrast-rgb), 0.16);--background-checked:var(--ion-color-contrast);--border-color:var(--ion-color-contrast)}";

const segmentMdCss = ".sc-ion-segment-md-h{--indicator-color-checked:initial;--ripple-color:currentColor;--color-activated:initial;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;display:flex;align-items:stretch;justify-content:center;width:100%;font-family:var(--ion-font-family, inherit);text-align:center}.segment-disabled.sc-ion-segment-md-h,.sc-ion-segment-md-s>.segment-button-disabled{pointer-events:none}.segment-scrollable.sc-ion-segment-md-h{justify-content:start;width:auto;overflow-x:scroll}.segment-scrollable.sc-ion-segment-md-h::-webkit-scrollbar{display:none}.sc-ion-segment-md-h{--background:none;--background-checked:none;--background-hover:rgba(var(--ion-color-primary-rgb, 56, 128, 255), 0.04);--background-activated:rgba(var(--ion-color-primary-rgb, 56, 128, 255), 0.16);--color:rgba(var(--ion-text-color-rgb, 0, 0, 0), 0.6);--color-checked:var(--ion-color-primary, #3880ff);--color-checked-disabled:var(--color-checked);--indicator-color:transparent}.segment-disabled.sc-ion-segment-md-h{opacity:0.3}.sc-ion-segment-md-h.ion-color.sc-ion-segment-md-s>ion-segment-button{--background-activated:rgba(var(--ion-color-base-rgb), 0.16);--ripple-color:var(--ion-color-base);background:transparent;color:rgba(var(--ion-text-color-rgb, 0, 0, 0), 0.6)}.sc-ion-segment-md-h.ion-color.sc-ion-segment-md-s>.segment-button-checked{--indicator-color-checked:var(--ion-color-base);color:var(--ion-color-base)}.sc-ion-segment-md-h.ion-color.sc-ion-segment-md-s>.segment-button-checked.activated{color:var(--ion-color-base)}@media (any-hover: hover){.sc-ion-segment-md-h.ion-color.sc-ion-segment-md-s>ion-segment-button:hover{background:rgba(var(--ion-color-base-rgb), 0.04)}}.sc-ion-segment-md-hion-toolbar:not(.ion-color):not(.ion-color).sc-ion-segment-md-s>ion-segment-button,ion-toolbar:not(.ion-color) .sc-ion-segment-md-h:not(.ion-color).sc-ion-segment-md-s>ion-segment-button{color:var(--ion-toolbar-color-unchecked, var(--color))}.sc-ion-segment-md-hion-toolbar:not(.ion-color):not(.ion-color).sc-ion-segment-md-s>.segment-button-checked,ion-toolbar:not(.ion-color) .sc-ion-segment-md-h:not(.ion-color).sc-ion-segment-md-s>.segment-button-checked{--indicator-color-checked:var(--ion-toolbar-color-checked, var(--color-checked));color:var(--ion-toolbar-color-checked, var(--color-checked))}.sc-ion-segment-md-hion-toolbar.ion-color:not(.ion-color).sc-ion-segment-md-s>ion-segment-button,ion-toolbar.ion-color .sc-ion-segment-md-h:not(.ion-color).sc-ion-segment-md-s>ion-segment-button{--background-hover:rgba(var(--ion-color-contrast-rgb), 0.04);--background-activated:var(--ion-color-base);--color:rgba(var(--ion-color-contrast-rgb), 0.6);--color-checked:var(--ion-color-contrast);--indicator-color-checked:var(--ion-color-contrast)}";

const Segment = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.didInit = false;
        /**
         * If `true`, the user cannot interact with the segment.
         */
        this.disabled = false;
        /**
         * If `true`, the segment buttons will overflow and the user can swipe to see them.
         */
        this.scrollable = false;
        this.ionChange = createEvent(this, "ionChange", 7);
        this.ionStyle = createEvent(this, "ionStyle", 7);
    }
    valueChanged(value) {
        if (this.didInit) {
            this.updateButtons();
            this.ionChange.emit({ value });
        }
    }
    segmentClick(ev) {
        const selectedButton = ev.target;
        this.value = selectedButton.value;
    }
    connectedCallback() {
        if (this.value === undefined) {
            const checked = this.getButtons().find(b => b.checked);
            if (checked) {
                this.value = checked.value;
            }
        }
        this.emitStyle();
    }
    componentDidLoad() {
        this.updateButtons();
        this.didInit = true;
    }
    emitStyle() {
        this.ionStyle.emit({
            'segment': true
        });
    }
    updateButtons() {
        const value = this.value;
        for (const button of this.getButtons()) {
            button.checked = (button.value === value);
        }
    }
    getButtons() {
        return Array.from(this.el.querySelectorAll('ion-segment-button'));
    }
    render() {
        const mode = getIonMode(this);
        return (h(Host, { class: Object.assign(Object.assign({}, createColorClasses(this.color)), { [mode]: true, 'segment-disabled': this.disabled, 'segment-scrollable': this.scrollable }) }));
    }
    get el() { return getElement(this); }
    static get watchers() { return {
        "value": ["valueChanged"]
    }; }
};
Segment.style = {
    /*STENCIL:MODE:ios*/ ios: segmentIosCss,
    /*STENCIL:MODE:md*/ md: segmentMdCss
};

export { Segment as ion_segment };
