import { g as getMode, C as Context, s as setMode } from './index-fec85944.js';
import { s as setupPlatforms, i as isPlatform } from './platform-2a611cf9.js';
import { c as config, a as configFromSession, b as configFromURL, s as saveConfig } from './config-d81853ed.js';

let mode;
const getIonMode = (ref) => {
    return (ref && getMode(ref)) || mode;
};
const ionicCoreGlobalScript = () => {
    const doc = document;
    const win = window;
    Context.config = config;
    const Ionic = win.Ionic = win.Ionic || {};
    // Setup platforms
    setupPlatforms(win);
    // create the Ionic.config from raw config object (if it exists)
    // and convert Ionic.config into a ConfigApi that has a get() fn
    const configObj = Object.assign(Object.assign(Object.assign(Object.assign({}, configFromSession(win)), { persistConfig: false }), Ionic.config), configFromURL(win));
    config.reset(configObj);
    if (config.getBoolean('persistConfig')) {
        saveConfig(win, configObj);
    }
    // first see if the mode was set as an attribute on <html>
    // which could have been set by the user, or by prerendering
    // otherwise get the mode via config settings, and fallback to md
    Ionic.config = config;
    Ionic.mode = mode = config.get('mode', (doc.documentElement.getAttribute('mode')) || (isPlatform(win, 'ios') ? 'ios' : 'md'));
    config.set('mode', mode);
    doc.documentElement.setAttribute('mode', mode);
    doc.documentElement.classList.add(mode);
    if (config.getBoolean('_testing')) {
        config.set('animated', false);
    }
    setMode((elm) => elm.mode = elm.mode || elm.getAttribute('mode') || mode);
};

export { getIonMode as g, ionicCoreGlobalScript as i };
