import { m as msg } from './messages-7ba0bfcd.js';

var nav;
(function (nav) {
    function goBack() {
        let router = document.querySelector('ion-router');
        router.back();
    }
    nav.goBack = goBack;
    function goHome() {
        _nav('/home', 'root');
    }
    nav.goHome = goHome;
    function goSync() {
        _nav('/sync', 'root');
    }
    nav.goSync = goSync;
    function goLogin() {
        _nav('/login', 'root');
    }
    nav.goLogin = goLogin;
    function goList(object, pagename, filter, defaults) {
        goPage('list', object, pagename, filter, defaults, 'forward');
    }
    nav.goList = goList;
    function goEdit(object, pagename, filter, defaults) {
        goPage('edit', object, pagename, filter, defaults, 'forward');
    }
    nav.goEdit = goEdit;
    function goView(object, pagename, filter, defaults) {
        goPage('view', object, pagename, filter, defaults, 'forward');
    }
    nav.goView = goView;
    function goInsert(object, pagename, defaults) {
        goPage('edit', object, pagename, null, defaults, 'forward');
    }
    nav.goInsert = goInsert;
    function goGallery(object, objectid) {
        _nav('/gallery/' + object + '/' + encodeURIComponent(objectid), 'forward');
    }
    nav.goGallery = goGallery;
    function goDocuments(object, objectid) {
        _nav('/documents/' + object + '/' + encodeURIComponent(objectid), 'forward');
    }
    nav.goDocuments = goDocuments;
    function transferList(object, pagename, filter, defaults) {
        goPage('list', object, pagename, filter, defaults, 'back');
    }
    nav.transferList = transferList;
    function transferEdit(object, pagename, filter, defaults) {
        goPage('edit', object, pagename, filter, defaults, 'back');
    }
    nav.transferEdit = transferEdit;
    function transferView(object, pagename, filter, defaults) {
        goPage('view', object, pagename, filter, defaults, 'back');
    }
    nav.transferView = transferView;
    function transferInsert(object, pagename, defaults) {
        goPage('edit', object, pagename, null, defaults, 'back');
    }
    nav.transferInsert = transferInsert;
    function transferGallery(object, objectid) {
        _nav('/gallery/' + object + '/' + encodeURIComponent(objectid), 'back');
    }
    nav.transferGallery = transferGallery;
    function transferDocuments(object, objectid) {
        _nav('/documents/' + object + '/' + encodeURIComponent(objectid), 'back');
    }
    nav.transferDocuments = transferDocuments;
    function goPage(type, object, pagename, filter, defaults, direction) {
        var esc = encodeURIComponent;
        let url = '/' + type + '/' + object;
        if (pagename) {
            url += '/page/' + esc(pagename);
        }
        if (filter) {
            url += '/filter/' + esc(filter);
        }
        if (defaults) {
            if (typeof defaults == 'object') {
                defaults = JSON.stringify(defaults);
                while (defaults.indexOf('"') > -1) {
                    defaults = defaults.replace('"', "'");
                }
            }
            url += '/defaults/' + esc(defaults);
        }
        _nav(url, direction);
    }
    nav.goPage = goPage;
    function currentUrl() {
        let router = document.querySelector('ion-router');
        let url = router.baseURI.substring(router.baseURI.indexOf('#'));
        if (url.startsWith('#')) {
            url = url.substr(1);
        }
        return url;
    }
    nav.currentUrl = currentUrl;
    async function _nav(url, direction) {
        if (currentUrl() == url) {
            //refresh current url
            debugger;
        }
        else {
            let router = document.querySelector('ion-router');
            let success = await router.push(url, direction);
            if (!success) {
                alert('Page not found');
            }
        }
    }
    nav._nav = _nav;
    function _goMenu(menu) {
        switch (menu.typeId) {
            case 'object':
                goPage(menu.pageTypeId, menu.objectName, menu.pageName, menu.objectWhere, null, 'root');
                break;
            default:
                msg.danger('Feature not implemented');
        }
    }
    nav._goMenu = _goMenu;
})(nav || (nav = {}));

export { nav as n };
